/*
Copyright (C) Christopher Fogelberg, Mengjie Zhang 2005

This file is part of VUWLGP.

VUWLGP is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

VUWLGP is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with VUWLGP; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
  
#include <iostream>
#include <string>

#include "MultiClassFitnessCase.h"

int main(int argc, char** argv) {
  std::cout << "Constructs an example MultiClassFitnessCase to test the Fitness Case classes"
	    << std::endl;

  std::string caseString = "name x y 1 className 5 4 3 2 1";
  VUWLGP::IFitnessCase<double>* fc = new VUWLGP::MultiClassFitnessCase<double>(caseString);

  std::cout << "Pattern file line: \"" << caseString << "\"" << std::endl;
  std::cout << "Featuers 0 through 4: " << fc->F(0) << " " << fc->F(1) << " " << fc->F(2) << " "
	    << fc->F(3) << " " << fc->F(4) << std::endl;
  std::cout << "FC Class: " 
	    << dynamic_cast<VUWLGP::MultiClassFitnessCase<double>*>(fc)->ClassNumber()
	    << "\n" << std::endl;

  delete fc;
  fc = VUWLGP::MultiClassFitnessCase<double>::Generate(caseString);

  std::cout << "Now testing the generate function:" << std::endl;
  std::cout << "Pattern file line: \"" << caseString << "\"" << std::endl;
  std::cout << "Featuers 0 through 4: " << fc->F(0) << " " << fc->F(1) << " " << fc->F(2) << " "
	    << fc->F(3) << " " << fc->F(4) << std::endl;
  std::cout << "FC Class: " 
	    << dynamic_cast<VUWLGP::MultiClassFitnessCase<double>*>(fc)->ClassNumber()
	    << std::endl;
  
  delete fc;

  return 0;
}
